Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.caucho.xml
Class DOMBuilder

    java.lang.Object
      |
      +--com.caucho.xml.DOMBuilder

All Implemented Interfaces:
  org.xml.sax.ContentHandler, XMLWriter

Direct Known Subclasses:
  TemplatesHandlerImpl, TransformerHandlerImpl

public class DOMBuilder
extends java.lang.Object
implements XMLWriter, org.xml.sax.ContentHandler

XMLWriter to create a DOM document.

Constructor Summary
`DOMBuilder()`

Method Summary
`void` | `attribute(java.lang.String uri, java.lang.String localName, java.lang.String qName, java.lang.String value)`
`void` | `cdata(char[] buffer, int offset, int length)`
`void` | `cdata(java.lang.String text)`
`void` | `characters(char[] buffer, int offset, int length)` Adds text characters to the current document.
`void` | `comment(char[] buf, int offset, int length)` Handles the callback for a comment.
`void` | `comment(java.lang.String data)` Handles the callback for a comment.
`void` | `dtd(QDocumentType dtd)`
`void` | `endDocument()` Receive notification of the end of a document.
`void` | `endElement(java.lang.String uri, java.lang.String localName, java.lang.String qName)` Receive notification of the end of an element.
`void` | `endPrefixMapping(java.lang.String prefix)` End the scope of a prefix-URI mapping.
`void` | `entityReference(java.lang.String name)`
`boolean` | `getEscapeText()`
`Node` | `getNode()`
`java.lang.String` | `getSystemId()`
`void` | `ignorableWhitespace(char[] buffer, int offset, int length)` Handles the callback for ignorable whitespace.
`void` | `init(Node top)`
`void` | `processingInstruction(java.lang.String name, java.lang.String data)` Receive notification of a processing instruction.
`void` | `setCoalescing(boolean isCoalescing)` Set true if text and cdata nodes should be combined.
`void` | `setDocumentLocator(org.xml.sax.Locator loc)` Receive an object for locating the origin of SAX document events.
`void` | `setEscapeText(boolean isEscaped)`
`void` | `setFilename(java.lang.String filename)`
`void` | `setLocation(java.lang.String filename, int line, int column)`
`void` | `setSkipWhitespace(boolean skipWhitespace)` Set true if ignorable whitespace should be skipped.
`void` | `setStrictXML(boolean isStrictXml)` Set true if we're only handling strict xml.
`void` | `setSystemId(java.lang.String systemId)`
`void` | `skippedEntity(java.lang.String s)` Receive notification of a skipped entity.
`void` | `startDocument()` Receive notification of the beginning of a document.
`void` | `startElement(QName name, com.caucho.xml.QAttributes attributes)`
`void` | `startElement(java.lang.String uri, java.lang.String localName, java.lang.String qName)`
`void` | `startElement(java.lang.String uri, java.lang.String localName, java.lang.String qName, org.xml.sax.Attributes attributes)` Receive notification of the beginning of an element.
`void` | `startPrefixMapping(java.lang.String prefix, java.lang.String name)` Begin the scope of a prefix-URI Namespace mapping.
`void` | `text(char[] buffer, int offset, int length)`
`void` | `text(java.lang.String text)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DOMBuilder

    public DOMBuilder()

Method Detail

### init

    public void init(Node top)

### setSystemId

    public void setSystemId(java.lang.String systemId)

### getSystemId

    public java.lang.String getSystemId()

### setFilename

    public void setFilename(java.lang.String filename)

### setStrictXML

    public void setStrictXML(boolean isStrictXml)

  Set true if we're only handling strict xml.

### setCoalescing

    public void setCoalescing(boolean isCoalescing)

  Set true if text and cdata nodes should be combined.

### setSkipWhitespace

    public void setSkipWhitespace(boolean skipWhitespace)

  Set true if ignorable whitespace should be skipped.

### setDocumentLocator

    public void setDocumentLocator(org.xml.sax.Locator loc)

  Description copied from interface: `org.xml.sax.ContentHandler`
  Receive an object for locating the origin of SAX document events.

  SAX parsers are strongly encouraged (though not absolutely required) to supply a locator: if it does so, it must supply the locator to the application by invoking this method before invoking any of the other methods in the ContentHandler interface.

  The locator allows the application to determine the end position of any document-related event, even if the parser is not reporting an error. Typically, the application will use this information for reporting its own errors (such as character content that does not match an application's business rules). The information returned by the locator is probably not sufficient for use with a search engine.

  Note that the locator will return correct information only during the invocation of the events in this interface. The application should not attempt to use it at any other time.

  Specified by:
    `setDocumentLocator` in interface `org.xml.sax.ContentHandler`
  Following copied from interface: `org.xml.sax.ContentHandler`
  Parameters:
    `locator` - An object that can return the location of any SAX document event.
  See Also:
    `Locator`

### startPrefixMapping

    public void startPrefixMapping(java.lang.String prefix,
                                   java.lang.String name)

  Description copied from interface: `org.xml.sax.ContentHandler`
  Begin the scope of a prefix-URI Namespace mapping.

  The information from this event is not necessary for normal Namespace processing: the SAX XML reader will automatically replace prefixes for element and attribute names when the `http://xml.org/sax/features/namespaces` feature is true (the default).

  There are cases, however, when applications need to use prefixes in character data or in attribute values, where they cannot safely be expanded automatically; the start/endPrefixMapping event supplies the information to the application to expand prefixes in those contexts itself, if necessary.

  Note that start/endPrefixMapping events are not guaranteed to be properly nested relative to each-other: all startPrefixMapping events will occur before the corresponding `startElement` event, and all `endPrefixMapping` events will occur after the corresponding `endElement` event, but their order is not otherwise guaranteed.

  There should never be start/endPrefixMapping events for the "xml" prefix, since it is predeclared and immutable.

  Specified by:
    `startPrefixMapping` in interface `org.xml.sax.ContentHandler`
  Following copied from interface: `org.xml.sax.ContentHandler`
  Parameters:
    `prefix` - The Namespace prefix being declared.
    `uri` - The Namespace URI the prefix is mapped to.
  Throws:
    `org.xml.sax.SAXException` - The client may throw an exception during processing.
  See Also:
    `ContentHandler.endPrefixMapping(java.lang.String)`, `ContentHandler.startElement(java.lang.String, java.lang.String, java.lang.String, org.xml.sax.Attributes)`

### endPrefixMapping

    public void endPrefixMapping(java.lang.String prefix)

  Description copied from interface: `org.xml.sax.ContentHandler`
  End the scope of a prefix-URI mapping.

  See `startPrefixMapping` for details. This event will always occur after the corresponding `endElement` event, but the order of `endPrefixMapping` events is not otherwise guaranteed.

  Specified by:
    `endPrefixMapping` in interface `org.xml.sax.ContentHandler`
  Following copied from interface: `org.xml.sax.ContentHandler`
  Parameters:
    `prefix` - The prefix that was being mapping.
  Throws:
    `org.xml.sax.SAXException` - The client may throw an exception during processing.
  See Also:
    `ContentHandler.startPrefixMapping(java.lang.String, java.lang.String)`, `ContentHandler.endElement(java.lang.String, java.lang.String, java.lang.String)`

### getNode

    public Node getNode()

### startDocument

    public void startDocument()

  Description copied from interface: `org.xml.sax.ContentHandler`
  Receive notification of the beginning of a document.

  The SAX parser will invoke this method only once, before any other methods in this interface or in `DTDHandler` (except for `setDocumentLocator`).

  Specified by:
    `startDocument` in interface `XMLWriter`
  Following copied from interface: `org.xml.sax.ContentHandler`
  Throws:
    `org.xml.sax.SAXException` - Any SAX exception, possibly wrapping another exception.
  See Also:
    `ContentHandler.endDocument()`

### endDocument

    public void endDocument()

  Description copied from interface: `org.xml.sax.ContentHandler`
  Receive notification of the end of a document.

  The SAX parser will invoke this method only once, and it will be the last method invoked during the parse. The parser shall not invoke this method until it has either abandoned parsing (because of an unrecoverable error) or reached the end of input.

  Specified by:
    `endDocument` in interface `XMLWriter`
  Following copied from interface: `org.xml.sax.ContentHandler`
  Throws:
    `org.xml.sax.SAXException` - Any SAX exception, possibly wrapping another exception.
  See Also:
    `ContentHandler.startDocument()`

### setLocation

    public void setLocation(java.lang.String filename,
                            int line,
                            int column)

  Specified by:
    `setLocation` in interface `XMLWriter`

### startElement

    public void startElement(java.lang.String uri,
                             java.lang.String localName,
                             java.lang.String qName)
                      throws java.io.IOException

  Specified by:
    `startElement` in interface `XMLWriter`

### startElement

    public void startElement(QName name,
                             com.caucho.xml.QAttributes attributes)
                      throws org.xml.sax.SAXException

### startElement

    public void startElement(java.lang.String uri,
                             java.lang.String localName,
                             java.lang.String qName,
                             org.xml.sax.Attributes attributes)
                      throws org.xml.sax.SAXException

  Description copied from interface: `org.xml.sax.ContentHandler`
  Receive notification of the beginning of an element.

  The Parser will invoke this method at the beginning of every element in the XML document; there will be a corresponding `endElement` event for every startElement event (even when the element is empty). All of the element's content will be reported, in order, before the corresponding endElement event.

  This event allows up to three name components for each element:

  1. the Namespace URI;
  2. the local name; and
  3. the qualified (prefixed) name.

  Any or all of these may be provided, depending on the values of the http://xml.org/sax/features/namespaces and the http://xml.org/sax/features/namespace-prefixes properties:

  - the Namespace URI and local name are required when the namespaces property is true (the default), and are optional when the namespaces property is false (if one is specified, both must be);
  - the qualified name is required when the namespace-prefixes property is true, and is optional when the namespace-prefixes property is false (the default).

  Note that the attribute list provided will contain only attributes with explicit values (specified or defaulted): #IMPLIED attributes will be omitted. The attribute list will contain attributes used for Namespace declarations (xmlns* attributes) only if the `http://xml.org/sax/features/namespace-prefixes` property is true (it is false by default, and support for a true value is optional).

  Specified by:
    `startElement` in interface `org.xml.sax.ContentHandler`
  Following copied from interface: `org.xml.sax.ContentHandler`
  Parameters:
    `uri` - The Namespace URI, or the empty string if the element has no Namespace URI or if Namespace processing is not being performed.
    `localName` - The local name (without prefix), or the empty string if Namespace processing is not being performed.
    `qName` - The qualified name (with prefix), or the empty string if qualified names are not available.
    `atts` - The attributes attached to the element. If there are no attributes, it shall be an empty Attributes object.
  Throws:
    `org.xml.sax.SAXException` - Any SAX exception, possibly wrapping another exception.
  See Also:
    `ContentHandler.endElement(java.lang.String, java.lang.String, java.lang.String)`, `Attributes`

### dtd

    public void dtd(QDocumentType dtd)

### attribute

    public void attribute(java.lang.String uri,
                          java.lang.String localName,
                          java.lang.String qName,
                          java.lang.String value)
                   throws java.io.IOException

  Specified by:
    `attribute` in interface `XMLWriter`

### endElement

    public void endElement(java.lang.String uri,
                           java.lang.String localName,
                           java.lang.String qName)

  Description copied from interface: `org.xml.sax.ContentHandler`
  Receive notification of the end of an element.

  The SAX parser will invoke this method at the end of every element in the XML document; there will be a corresponding `startElement` event for every endElement event (even when the element is empty).

  For information on the names, see startElement.

  Specified by:
    `endElement` in interface `XMLWriter`
  Following copied from interface: `org.xml.sax.ContentHandler`
  Parameters:
    `uri` - The Namespace URI, or the empty string if the element has no Namespace URI or if Namespace processing is not being performed.
    `localName` - The local name (without prefix), or the empty string if Namespace processing is not being performed.
    `qName` - The qualified XML 1.0 name (with prefix), or the empty string if qualified names are not available.
  Throws:
    `org.xml.sax.SAXException` - Any SAX exception, possibly wrapping another exception.

### processingInstruction

    public void processingInstruction(java.lang.String name,
                                      java.lang.String data)

  Description copied from interface: `org.xml.sax.ContentHandler`
  Receive notification of a processing instruction.

  The Parser will invoke this method once for each processing instruction found: note that processing instructions may occur before or after the main document element.

  A SAX parser must never report an XML declaration (XML 1.0, section 2.8) or a text declaration (XML 1.0, section 4.3.1) using this method.

  Specified by:
    `processingInstruction` in interface `XMLWriter`
  Following copied from interface: `org.xml.sax.ContentHandler`
  Parameters:
    `target` - The processing instruction target.
    `data` - The processing instruction data, or null if none was supplied. The data does not include any whitespace separating it from the target.
  Throws:
    `org.xml.sax.SAXException` - Any SAX exception, possibly wrapping another exception.

### comment

    public void comment(char[] buf,
                        int offset,
                        int length)
                 throws org.xml.sax.SAXException

  Handles the callback for a comment.
  Parameters:
    `data` - the content of the comment.

### comment

    public void comment(java.lang.String data)
                 throws java.io.IOException

  Handles the callback for a comment.
  Specified by:
    `comment` in interface `XMLWriter`
  Parameters:
    `data` - the content of the comment.

### getEscapeText

    public boolean getEscapeText()

  Specified by:
    `getEscapeText` in interface `XMLWriter`

### setEscapeText

    public void setEscapeText(boolean isEscaped)

  Specified by:
    `setEscapeText` in interface `XMLWriter`

### text

    public void text(java.lang.String text)
              throws java.io.IOException

  Specified by:
    `text` in interface `XMLWriter`

### text

    public void text(char[] buffer,
                     int offset,
                     int length)
              throws java.io.IOException

  Specified by:
    `text` in interface `XMLWriter`

### characters

    public void characters(char[] buffer,
                           int offset,
                           int length)
                    throws org.xml.sax.SAXException

  Adds text characters to the current document.
  Specified by:
    `characters` in interface `org.xml.sax.ContentHandler`
  Following copied from interface: `org.xml.sax.ContentHandler`
  Parameters:
    `ch` - The characters from the XML document.
    `start` - The start position in the array.
    `length` - The number of characters to read from the array.
  Throws:
    `org.xml.sax.SAXException` - Any SAX exception, possibly wrapping another exception.
  See Also:
    `ContentHandler.ignorableWhitespace(char[], int, int)`, `Locator`

### ignorableWhitespace

    public void ignorableWhitespace(char[] buffer,
                                    int offset,
                                    int length)
                             throws org.xml.sax.SAXException

  Handles the callback for ignorable whitespace.
  Specified by:
    `ignorableWhitespace` in interface `org.xml.sax.ContentHandler`
  Parameters:
    `buffer` - the character buffer containing the whitespace.
    `offset` - starting offset into the character buffer.
    `length` - number of characters in the buffer.

### entityReference

    public void entityReference(java.lang.String name)

### skippedEntity

    public void skippedEntity(java.lang.String s)

  Description copied from interface: `org.xml.sax.ContentHandler`
  Receive notification of a skipped entity.

  The Parser will invoke this method once for each entity skipped. Non-validating processors may skip entities if they have not seen the declarations (because, for example, the entity was declared in an external DTD subset). All processors may skip external entities, depending on the values of the `http://xml.org/sax/features/external-general-entities` and the `http://xml.org/sax/features/external-parameter-entities` properties.

  Specified by:
    `skippedEntity` in interface `org.xml.sax.ContentHandler`
  Following copied from interface: `org.xml.sax.ContentHandler`
  Parameters:
    `name` - The name of the skipped entity. If it is a parameter entity, the name will begin with '%', and if it is the external DTD subset, it will be the string "[dtd]".
  Throws:
    `org.xml.sax.SAXException` - Any SAX exception, possibly wrapping another exception.

### cdata

    public void cdata(java.lang.String text)
               throws java.io.IOException

  Specified by:
    `cdata` in interface `XMLWriter`

### cdata

    public void cdata(char[] buffer,
                      int offset,
                      int length)
               throws java.io.IOException

  Specified by:
    `cdata` in interface `XMLWriter`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD